#!/usr/bin/perl

#
# HoneyScripts - Very simple and limited Perl scripts for naive honeypots
#
#              - Coded by Arne Vidstrom, http://vidstrom.net/stools/honeyscripts/
#

#
# This program is free software; you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with this program;
# if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
# MA  02111-1307, USA.
#

use Socket;
use POSIX ":sys_wait_h";

$max_chars = 10000;
$server_name = "Server: Apache/1.3.3 (Unix) PHP/3.0.18";
@no_log_patterns = ("root.exe", "/c/", "/d/", "httpodbc.dll", "/winnt/system32/cmd.exe?/c+dir", "%u8190%u00c3%u0003%u8b00%u531b%u53ff%u0078%u0000%u00=a");
$idle_timeout = 30;
$debug_mode = 0;
$log_file = "/var/log/wwwhoney.log";
$enable_no_log = 1;
$log_file_no = "/var/log/wwwnohoney.log";
$log_file_conn = "/var/log/wwwconnhoney.log";

$hon_port = $ARGV[0];
select ("STDOUT");
$| = 1;
socket(MASTERSOCKET, PF_INET, SOCK_STREAM, getprotobyname('tcp'));
setsockopt(MASTERSOCKET, SOL_SOCKET, SO_REUSEADDR, 1);
$listen_at = sockaddr_in($hon_port, INADDR_ANY);
bind(MASTERSOCKET, $listen_at) or die "Couldn't bind to port\n";
listen(MASTERSOCKET, 5) or die "Couldn't listen on port\n";
do {
	do {
		$chd = waitpid(-1, WNOHANG);
    } while (-1 != $chd);
	$dummy = accept(CLIENTSOCKET, MASTERSOCKET);
	if ($dummy) {
		$retval = fork();
		if ($retval == 0) {
			&honey;
		} else {
			close(CLIENTSOCKET);
		}
	}
} while ($dummy);
close(MASTERSOCKET);

sub honey {
	$other_end = getpeername(CLIENTSOCKET) or die "Couldn't get client IP\n";
	($port, $iaddr) = unpack_sockaddr_in($other_end);
	$ip_address = inet_ntoa($iaddr);
	if (1 == $debug_mode) {
		print("new client accepted from $ip_address\n");
	}
	$done = 0;
	do {
		$rin = '';
		vec($rin, fileno(CLIENTSOCKET), 1) = 1;
		$timeout = $idle_timeout;
		$nfound = select($rout = $rin, undef, undef, $timeout);
		if (0 >= $nfound) {
			$done = 1;
		}
		else {
			if (vec($rout, fileno(CLIENTSOCKET), 1)) {
				$maxlen = 1;
				$recvres = recv(CLIENTSOCKET, $data_buffer, $maxlen, 0);
				if (1 == defined($recvres)) {
					$temp = length($data_buffer);
					if (0 == length($data_buffer)) {
						$done = 1;
					}
					else {
						if ($num_chars < $max_chars) {
							$curr_line .= $data_buffer;
							if (-1 != index($curr_line, "\r\n\r\n")) {
								$done = 1;
							}
							if (-1 != index($curr_line, "\n\n")) {
								$done = 1;
							}
						}
						else {
							$done = 1;
						}
					}
				}
				else {
					$done = 1;
				}
			}
		}
	} while ($done != 1);
	if (0 == index($curr_line, "GET / HTTP/")) {
		$line_to_send = "HTTP/1.1 200 OK\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = $server_name . "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$curr_date = localtime;
		$line_to_send = "Date: $curr_date\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "Connection: Close\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "Content-Type: text/html\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "<HTML><HEAD><TITLE>Under Construction</TITLE></HEAD><BODY BGCOLOR=\"BLACK\" TEXT=\"#FF00FF\"><FONT FACE=\"Verdana, Arial\" SIZE=\"2\">Under Construction: Please come back later!</FONT></BODY></HTML>\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
	}
	else {
		$line_to_send = "HTTP/1.1 200 OK\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = $server_name . "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$curr_date = localtime;
		$line_to_send = "Date: $curr_date\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "Connection: Close\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "Content-Type: text/html\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
		$line_to_send = "\r\n";
		send(CLIENTSOCKET, $line_to_send, 0);
	}
	$no_log = 0;
	foreach $no_log_temp (@no_log_patterns) {
		if (-1 != index($curr_line, $no_log_temp)) {
			$no_log = 1;
		}
	}
	if (0 == $no_log) {
		if (0 == ($curr_line =~ /^[\s|\r|\n]*$/)) {
			while ($curr_line =~ /[\r|\n]$/) {
				chop($curr_line);
			}
			open(LOGFILE, ">>$log_file") or die "Unable to open log file";
			flock(LOGFILE, LOCK_EX);
			$curr_date = localtime;
			print LOGFILE ("From $ip_address to port $hon_port at $curr_date ->\n\n$curr_line\n\n");
			print LOGFILE ("-\n\n");
			flock(LOGFILE, LOCK_UN);
			close(LOGFILE);
		}
		else {
			while ($curr_line =~ /[\r|\n]$/) {
				chop($curr_line);
			}
			open(LOGFILECONN, ">>$log_file_conn") or die "Unable to open log file";
			flock(LOGFILECONN, LOCK_EX);
			$curr_date = localtime;
			print LOGFILECONN ("From $ip_address to port $hon_port at $curr_date ->\n\n$curr_line\n\n");
			print LOGFILECONN ("-\n\n");
			flock(LOGFILECONN, LOCK_UN);
			close(LOGFILECONN);
		}
	}
	else {
		if (1 == $enable_no_log) {
			while ($curr_line =~ /[\r|\n]$/) {
				chop($curr_line);
			}
			open(LOGFILEN, ">>$log_file_no") or die "Unable to open no log file";
			flock(LOGFILEN, LOCK_EX);
			$curr_date = localtime;
			print LOGFILEN ("From $ip_address to port $hon_port at $curr_date ->\n\n$curr_line\n\n");
			print LOGFILEN ("-\n\n");
			flock(LOGFILEN, LOCK_UN);
			close(LOGFILEN);
		}
	}
	if (1 == $debug_mode) {
		printf("client disconnected\n");
	}
	close(CLIENTSOCKET);
	exit(0);
}
